﻿/**
 * Copyright(c) Live2D Inc. All rights reserved.
 *
 * Use of this source code is governed by the Live2D Open Software license
 * that can be found at https://www.live2d.com/eula/live2d-open-software-license-agreement_en.html.
 */


using Live2D.Cubism.Core;


namespace Live2D.Cubism.Framework
{
    /// <summary>
    /// Enumeration of <see cref="CubismParameter"/> blend modes.
    /// </summary>
    public enum CubismParameterBlendMode
    {
        /// <summary>
        /// Override blending.
        /// </summary>
        Override,

        /// <summary>
        /// Additive blending.
        /// </summary>
        Additive,

        /// <summary>
        /// Multiply blending.
        /// </summary>
        Multiply
    }
}
